# Interface DeepClientInstance<L>

interface DeepClientInstance<L> {
DeepContext: Context<DeepClient<Link<Id>>>;
DeepProvider: ((__namedParameters) => Element);
apolloClient: IApolloClient<any>;
deep: DeepClientInstance<L>;
defaultDeleteName?: string;
defaultInsertName?: string;
defaultSelectName?: string;
defaultUpdateName?: string;
deleteReturning?: string;
filesSelectReturning?: string;
handleAuth?: ((linkId?, token?) => any);
insertReturning?: string;
linkId?: Id;
linksSelectReturning?: string;
minilinks: MinilinksResult<L>;
namespace?: string;
returning?: string;
selectReturning?: string;
selectorsSelectReturning?: string;
table?: string;
token?: string;
unsafe?: any;
updateReturning?: string;
useDeep: (() => DeepClient<Link<Id>>);
useDeepQuery: (<Table, LL>(query, options?) => {
data?: LL[];
error?: any;
loading: boolean;
});
useDeepSubscription: (<Table, LL>(query, options?) => UseDeepSubscriptionResult<LL>);
useMinilinksQuery: ((query) => L[]);
useMinilinksSubscription: ((query) => L[]);
valuesSelectReturning?: string;
Traveler(links): Traveler;
await(id): Promise<boolean>;
can(objectIds, subjectIds, actionIds): Promise<boolean>;
delete<TTable>(exp, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
guest(options): Promise<DeepClientAuthResult>;
id(start, ...path): Promise<Id>;
idLocal(start, ...path): Id;
insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
jwt(options): Promise<DeepClientAuthResult>;
login(options): Promise<DeepClientAuthResult>;
logout(): Promise<DeepClientAuthResult>;
reserve<LL>(count): Promise<Id[]>;
select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>;
serial(options): Promise<DeepClientResult<{
id: any;
}[]>>;
serializeQuery(exp, env?, unvertualizeId?): any;
serializeWhere(exp, env?): any;
stringify(any?): string;
subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>;
unvertualizeId(id): Id;
update<TTable>(exp, value, options?): Promise<DeepClientResult<{
id: any;
}[]>>;
}

#### Type Parameters

- L extends Link<Id> = Link<Id>

#### Hierarchy (view full)

- DeepClientInstance
  - CyberDeepClientInstance

#### Implemented by

- DeepClient

- Defined in work/deeplinks/deeplinks/imports/client.tsx:357

#####
Index

### Properties

DeepContext
DeepProvider
apolloClient
deep
defaultDeleteName?
defaultInsertName?
defaultSelectName?
defaultUpdateName?
deleteReturning?
filesSelectReturning?
handleAuth?
insertReturning?
linkId?
linksSelectReturning?
minilinks
namespace?
returning?
selectReturning?
selectorsSelectReturning?
table?
token?
unsafe?
updateReturning?
useDeep
useDeepQuery
useDeepSubscription
useMinilinksQuery
useMinilinksSubscription
valuesSelectReturning?

### Methods

Traveler
await
can
delete
guest
id
idLocal
insert
jwt
login
logout
reserve
select
serial
serializeQuery
serializeWhere
stringify
subscribe
unvertualizeId
update

## Properties

### DeepContext

DeepContext: Context<DeepClient<Link<Id>>>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:428

### DeepProvider

DeepProvider: ((__namedParameters) => Element)

#### Type declaration

- - (__namedParameters): Element

  - #### Parameters

    - __namedParameters: {
      apolloClient?: IApolloClient<any>;
      children: any;
      minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>;
      namespace?: string;
      }

      - ##### `Optional` apolloClient?: IApolloClient<any>

      - ##### children: any

      - ##### `Optional` minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>

      - ##### `Optional` namespace?: string

    #### Returns Element

- Defined in work/deeplinks/deeplinks/imports/client.tsx:427

### apolloClient

apolloClient: IApolloClient<any>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:366

### deep

deep: DeepClientInstance<L>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:364

### `Optional` defaultDeleteName

defaultDeleteName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:383

### `Optional` defaultInsertName

defaultInsertName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:381

### `Optional` defaultSelectName

defaultSelectName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:380

### `Optional` defaultUpdateName

defaultUpdateName?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:382

### `Optional` deleteReturning

deleteReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:378

### `Optional` filesSelectReturning

filesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:375

### `Optional` handleAuth

handleAuth?: ((linkId?, token?) => any)

#### Type declaration

- - (linkId?, token?): any

  - #### Parameters

    - `Optional` linkId: Id
    - `Optional` token: string

    #### Returns any

- Defined in work/deeplinks/deeplinks/imports/client.tsx:362

### `Optional` insertReturning

insertReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:376

### `Optional` linkId

linkId?: Id

- Defined in work/deeplinks/deeplinks/imports/client.tsx:360

### `Optional` linksSelectReturning

linksSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:372

### minilinks

minilinks: MinilinksResult<L>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:367

### `Optional` namespace

namespace?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:358

### `Optional` returning

returning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:369

### `Optional` selectReturning

selectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:371

### `Optional` selectorsSelectReturning

selectorsSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:374

### `Optional` table

table?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:368

### `Optional` token

token?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:361

### `Optional` unsafe

unsafe?: any

- Defined in work/deeplinks/deeplinks/imports/client.tsx:385

### `Optional` updateReturning

updateReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:377

### useDeep

useDeep: (() => DeepClient<Link<Id>>)

#### Type declaration

- - (): DeepClient<Link<Id>>

  - #### Returns DeepClient<Link<Id>>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:426

### useDeepQuery

useDeepQuery: (<Table, LL>(query, options?) => {
data?: LL[];
error?: any;
loading: boolean;
})

#### Type declaration

- - <Table, LL>(query, options?): {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

  - #### Type Parameters

    - Table extends "links" | "can" | "tree" | "selectors" | "numbers" | "strings" | "objects" | "handlers"
    - LL = Link<Id>

    #### Parameters

    - query: Exp<Table>
    - `Optional` options: Options<Table>

    #### Returns {
    data?: LL[];
    error?: any;
    loading: boolean;
    }

    - ##### `Optional` data?: LL[]

    - ##### `Optional` error?: any

    - ##### loading: boolean

- Defined in work/deeplinks/deeplinks/imports/client.tsx:423

### useDeepSubscription

useDeepSubscription: (<Table, LL>(query, options?) => UseDeepSubscriptionResult<LL>)

#### Type declaration

- - <Table, LL>(query, options?): UseDeepSubscriptionResult<LL>

  - #### Type Parameters

    - Table extends "links" | "can" | "tree" | "selectors" | "numbers" | "strings" | "objects" | "handlers"
    - LL = Link<Id>

    #### Parameters

    - query: Exp<Table>
    - `Optional` options: Options<Table>

    #### Returns UseDeepSubscriptionResult<LL>

- Defined in work/deeplinks/deeplinks/imports/client.tsx:422

### useMinilinksQuery

useMinilinksQuery: ((query) => L[])

#### Type declaration

- - (query): L[]

  - #### Parameters

    - query: Exp<"links">

    #### Returns L[]

- Defined in work/deeplinks/deeplinks/imports/client.tsx:424

### useMinilinksSubscription

useMinilinksSubscription: ((query) => L[])

#### Type declaration

- - (query): L[]

  - #### Parameters

    - query: Exp<"links">

    #### Returns L[]

- Defined in work/deeplinks/deeplinks/imports/client.tsx:425

### `Optional` valuesSelectReturning

valuesSelectReturning?: string

- Defined in work/deeplinks/deeplinks/imports/client.tsx:373

## Methods

### Traveler

- Traveler(links): Traveler

- #### Parameters

  - links: Link<Id>[]

  #### Returns Traveler

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:430

### await

- await(id): Promise<boolean>

- #### Parameters

  - id: Id

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:402

### can

- can(objectIds, subjectIds, actionIds): Promise<boolean>

- #### Parameters

  - objectIds: Id[]
  - subjectIds: Id[]
  - actionIds: Id[]

  #### Returns Promise<boolean>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:420

### delete

- delete<TTable>(exp, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends "links" | "numbers" | "strings" | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:396

### guest

- guest(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientGuestOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:412

### id

- id(start, ...path): Promise<Id>

- #### Parameters

  - start: string | number | QueryLink | Id[]
  - `Rest` ...path: DeepClientPathItem[]

  #### Returns Promise<Id>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:409

### idLocal

- idLocal(start, ...path): Id

- #### Parameters

  - start: DeepClientStartItem
  - `Rest` ...path: DeepClientPathItem[]

  #### Returns Id

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:410

### insert

- insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends "links" | "numbers" | "strings" | "objects"
  - LL = L

  #### Parameters

  - objects: InsertObjects<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:392

### jwt

- jwt(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:414

### login

- login(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:416

### logout

- logout(): Promise<DeepClientAuthResult>

- #### Returns Promise<DeepClientAuthResult>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:418

### reserve

- reserve<LL>(count): Promise<Id[]>

- #### Type Parameters

  - LL = L

  #### Parameters

  - count: number

  #### Returns Promise<Id[]>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:400

### select

- select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>

- #### Type Parameters

  - TTable extends "links" | "can" | "tree" | "selectors" | "numbers" | "strings" | "objects" | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Promise<DeepClientResult<number | LL[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:389

### serial

- serial(options): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Parameters

  - options: AsyncSerialParams

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:398

### serializeQuery

- serializeQuery(exp, env?, unvertualizeId?): any

- #### Parameters

  - exp: any
  - `Optional` env: string
  - `Optional` unvertualizeId: ((id) => Id)
    - - (id): Id

      - #### Parameters

        - id: Id

        #### Returns Id

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:406

### serializeWhere

- serializeWhere(exp, env?): any

- #### Parameters

  - exp: any
  - `Optional` env: string

  #### Returns any

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:405

### stringify

- stringify(any?): string

- #### Parameters

  - `Optional` any: any

  #### Returns string

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:387

### subscribe

- subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>

- #### Type Parameters

  - TTable extends "links" | "can" | "tree" | "selectors" | "numbers" | "strings" | "objects" | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Observable<number | LL[]>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:390

### unvertualizeId

- unvertualizeId(id): Id

- #### Parameters

  - id: Id

  #### Returns Id

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:407

### update

- update<TTable>(exp, value, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends "links" | "numbers" | "strings" | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - value: UpdateValue<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:394